package ca.recrown.islandsurvivalcraft.world;

import java.util.Random;
import java.util.UUID;
import java.util.concurrent.ConcurrentHashMap;

import org.bukkit.World;

import ca.recrown.islandsurvivalcraft.world.generation.IslandBiomeGenerator;
import ca.recrown.islandsurvivalcraft.world.generation.IslandWorldGenerator;

/**
 * Alternates the data used on a per world basis.
 * Uses IslandWorldGenerator as the container for each world.
 */
public class IslandWorldGeneratorAlternator {
    private final ConcurrentHashMap<UUID, IslandWorldGenerator> chunkGenerators;
    private final IslandBiomeGenerator islandBiomeGenerator;

    public IslandWorldGeneratorAlternator(IslandBiomeGenerator biomeGenerator) {
        this.chunkGenerators = new ConcurrentHashMap<>();
        this.islandBiomeGenerator = biomeGenerator;
    }

    public IslandWorldGenerator getIslandChunkGeneratorSystem(World world, Random random) {
        UUID wUuid = world.getUID();
        if (!chunkGenerators.containsKey(wUuid)) {
            chunkGenerators.put(wUuid, new IslandWorldGenerator(world, islandBiomeGenerator.getInstance(), random));
        }
        return chunkGenerators.get(wUuid);
    }
}